(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     29457,        777]
NotebookOptionsPosition[     28726,        748]
NotebookOutlinePosition[     29083,        764]
CellTagsIndexPosition[     29040,        761]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"H", "[", "x_", "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "x"}], "*", 
     RowBox[{"Log2", "[", "x", "]"}]}], "-", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", "x"}], ")"}], "*", 
     RowBox[{"Log2", "[", 
      RowBox[{"1", "-", "x"}], "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Hinv", "[", "x_", "]"}], ":=", 
    RowBox[{
     RowBox[{"InverseFunction", "[", "H", "]"}], "[", "x", "]"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", "FDD", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"t", "[", "k_", "]"}], ":=", 
    RowBox[{"Hinv", "[", 
     RowBox[{"1", "-", "k"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", "BDD", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"t", "[", "k_", "]"}], ":=", 
     RowBox[{
      RowBox[{"Hinv", "[", 
       RowBox[{"1", "-", "k"}], "]"}], "/", "2"}]}], ";"}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "Asymptotic", " ", "Complexity", " ", "Formulas", " ", "according", " ", 
    "to", " ", "paper", " ", "notation"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"P", "[", 
    RowBox[{"l_", ",", "p_", ",", "k_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"k", "+", "l"}], ")"}], "*", 
     RowBox[{"H", "[", 
      RowBox[{"p", "/", 
       RowBox[{"(", 
        RowBox[{"k", "+", "l"}], ")"}]}], "]"}]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", "k", "-", "l"}], ")"}], "*", 
     RowBox[{"H", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"t", "[", "k", "]"}], "-", "p"}], ")"}], "/", 
       RowBox[{"(", 
        RowBox[{"1", "-", "k", "-", "l"}], ")"}]}], "]"}]}], "-", 
    RowBox[{"H", "[", 
     RowBox[{"t", "[", "k", "]"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"p1", "[", 
    RowBox[{"l_", ",", "p_", ",", "e1_", ",", "e2_", ",", "k_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"p", "/", "2"}], "+", "e1"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"p2", "[", 
    RowBox[{"l_", ",", "p_", ",", "e1_", ",", "e2_", ",", "k_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"p1", "[", 
      RowBox[{"l", ",", "p", ",", "e1", ",", "e2", ",", "k"}], "]"}], "/", 
     "2"}], "+", "e2"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"r0", "[", 
    RowBox[{"l_", ",", "p_", ",", "e1_", ",", "e2_", ",", "k_"}], "]"}], ":=",
    "l"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"r1", "[", 
    RowBox[{"l_", ",", "p_", ",", "e1_", ",", "e2_", ",", "k_"}], "]"}], ":=", 
   RowBox[{"p", "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"k", "+", "l", "-", "p"}], ")"}], "*", 
     RowBox[{"H", "[", 
      RowBox[{"e1", "/", 
       RowBox[{"(", 
        RowBox[{"k", "+", "l", "-", "p"}], ")"}]}], "]"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"r2", "[", 
    RowBox[{"l_", ",", "p_", ",", "e1_", ",", "e2_", ",", "k_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"p1", "[", 
     RowBox[{"l", ",", "p", ",", "e1", ",", "e2", ",", "k"}], "]"}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"k", "+", "l", "-", 
       RowBox[{"p1", "[", 
        RowBox[{"l", ",", "p", ",", "e1", ",", "e2", ",", "k"}], "]"}]}], 
      ")"}], "*", 
     RowBox[{"H", "[", 
      RowBox[{"e2", "/", 
       RowBox[{"(", 
        RowBox[{"k", "+", "l", "-", 
         RowBox[{"p1", "[", 
          RowBox[{"l", ",", "p", ",", "e1", ",", "e2", ",", "k"}], "]"}]}], 
        ")"}]}], "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"r3", "[", 
    RowBox[{"l_", ",", "p_", ",", "e1_", ",", "e2_", ",", "k_"}], "]"}], ":=",
    "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"S3", "[", 
    RowBox[{"l_", ",", "p_", ",", "e1_", ",", "e2_", ",", "k_"}], "]"}], ":=", 
   RowBox[{"0.5", "*", 
    RowBox[{"(", 
     RowBox[{"k", "+", "l"}], ")"}], "*", 
    RowBox[{"H", "[", 
     RowBox[{
      RowBox[{"p2", "[", 
       RowBox[{"l", ",", "p", ",", "e1", ",", "e2", ",", "k"}], "]"}], "/", 
      RowBox[{"(", 
       RowBox[{"k", "+", "l"}], ")"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"S2", "[", 
    RowBox[{"l_", ",", "p_", ",", "e1_", ",", "e2_", ",", "k_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"k", "+", "l"}], ")"}], "*", 
     RowBox[{"H", "[", 
      RowBox[{
       RowBox[{"p2", "[", 
        RowBox[{"l", ",", "p", ",", "e1", ",", "e2", ",", "k"}], "]"}], "/", 
       RowBox[{"(", 
        RowBox[{"k", "+", "l"}], ")"}]}], "]"}]}], "-", 
    RowBox[{"r2", "[", 
     RowBox[{"l", ",", "p", ",", "e1", ",", "e2", ",", "k"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"S1", "[", 
    RowBox[{"l_", ",", "p_", ",", "e1_", ",", "e2_", ",", "k_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"k", "+", "l"}], ")"}], "*", 
     RowBox[{"H", "[", 
      RowBox[{
       RowBox[{"p1", "[", 
        RowBox[{"l", ",", "p", ",", "e1", ",", "e2", ",", "k"}], "]"}], "/", 
       RowBox[{"(", 
        RowBox[{"k", "+", "l"}], ")"}]}], "]"}]}], "-", 
    RowBox[{"r1", "[", 
     RowBox[{"l", ",", "p", ",", "e1", ",", "e2", ",", "k"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"C3", "[", 
    RowBox[{"l_", ",", "p_", ",", "e1_", ",", "e2_", ",", "k_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"2", "*", 
     RowBox[{"S3", "[", 
      RowBox[{"l", ",", "p", ",", "e1", ",", "e2", ",", "k"}], "]"}]}], "-", 
    RowBox[{"r2", "[", 
     RowBox[{"l", ",", "p", ",", "e1", ",", "e2", ",", "k"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"C2", "[", 
    RowBox[{"l_", ",", "p_", ",", "e1_", ",", "e2_", ",", "k_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"2", "*", 
     RowBox[{"S2", "[", 
      RowBox[{"l", ",", "p", ",", "e1", ",", "e2", ",", "k"}], "]"}]}], "+", 
    RowBox[{"r2", "[", 
     RowBox[{"l", ",", "p", ",", "e1", ",", "e2", ",", "k"}], "]"}], "-", 
    RowBox[{"r1", "[", 
     RowBox[{"l", ",", "p", ",", "e1", ",", "e2", ",", "k"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"C1", "[", 
    RowBox[{"l_", ",", "p_", ",", "e1_", ",", "e2_", ",", "k_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"2", "*", 
     RowBox[{"S1", "[", 
      RowBox[{"l", ",", "p", ",", "e1", ",", "e2", ",", "k"}], "]"}]}], "+", 
    RowBox[{"r1", "[", 
     RowBox[{"l", ",", "p", ",", "e1", ",", "e2", ",", "k"}], "]"}], "-", 
    "l"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"T3", "[", 
    RowBox[{"l_", ",", "p_", ",", "e1_", ",", "e2_", ",", "k_"}], "]"}], ":=", 
   RowBox[{"Max", "[", 
    RowBox[{
     RowBox[{"S3", "[", 
      RowBox[{"l", ",", "p", ",", "e1", ",", "e2", ",", "k"}], "]"}], ",", 
     RowBox[{"C3", "[", 
      RowBox[{"l", ",", "p", ",", "e1", ",", "e2", ",", "k"}], "]"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"T2", "[", 
    RowBox[{"l_", ",", "p_", ",", "e1_", ",", "e2_", ",", "k_"}], "]"}], ":=", 
   RowBox[{"Max", "[", 
    RowBox[{
     RowBox[{"S2", "[", 
      RowBox[{"l", ",", "p", ",", "e1", ",", "e2", ",", "k"}], "]"}], ",", 
     RowBox[{"C2", "[", 
      RowBox[{"l", ",", "p", ",", "e1", ",", "e2", ",", "k"}], "]"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"T1", "[", 
     RowBox[{"l_", ",", "p_", ",", "e1_", ",", "e2_", ",", "k_"}], "]"}], ":=", 
    RowBox[{"Max", "[", 
     RowBox[{
      RowBox[{"S1", "[", 
       RowBox[{"l", ",", "p", ",", "e1", ",", "e2", ",", "k"}], "]"}], ",", 
      RowBox[{"C1", "[", 
       RowBox[{"l", ",", "p", ",", "e1", ",", "e2", ",", "k"}], "]"}]}], 
     "]"}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"Overall", " ", "Time", " ", "Complexity"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"l_", ",", "p_", ",", "e1_", ",", "e2_", ",", "k_"}], "]"}], ":=", 
    RowBox[{"Max", "[", 
     RowBox[{
      RowBox[{"T1", "[", 
       RowBox[{"l", ",", "p", ",", "e1", ",", "e2", ",", "k"}], "]"}], ",", 
      RowBox[{"T2", "[", 
       RowBox[{"l", ",", "p", ",", "e1", ",", "e2", ",", "k"}], "]"}], ",", 
      RowBox[{"T3", "[", 
       RowBox[{"l", ",", "p", ",", "e1", ",", "e2", ",", "k"}], "]"}]}], 
     "]"}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"Overall", " ", "Space", " ", "Complexity"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{"l_", ",", "p_", ",", "e1_", ",", "e2_", ",", "k_"}], "]"}], ":=", 
   RowBox[{"Max", "[", 
    RowBox[{
     RowBox[{"S1", "[", 
      RowBox[{"l", ",", "p", ",", "e1", ",", "e2", ",", "k"}], "]"}], ",", 
     RowBox[{"S2", "[", 
      RowBox[{"l", ",", "p", ",", "e1", ",", "e2", ",", "k"}], "]"}], ",", 
     RowBox[{"S3", "[", 
      RowBox[{"l", ",", "p", ",", "e1", ",", "e2", ",", "k"}], "]"}]}], 
    "]"}]}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "Total", " ", "Complexity", " ", "including", " ", "constraints"}], ",", 
    " ", 
    RowBox[{
    "if", " ", "constraints", " ", "are", " ", "not", " ", "fulfilled"}], ",",
     " ", 
    RowBox[{
    "set", " ", "complexity", " ", "to", " ", "Brute", " ", "Force", " ", 
     "Complexity"}], ",", " ", 
    RowBox[{
    "this", " ", "allows", " ", "for", " ", "better", " ", "results", " ", 
     "in", " ", "the", " ", "optimization"}]}], "*)"}], 
  RowBox[{
   RowBox[{
    RowBox[{"CompBJMM", "[", 
     RowBox[{"l_", ",", "p_", ",", "e1_", ",", "e2_", ",", "k_"}], "]"}], ":=", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"0", "<", "l", "<", 
        RowBox[{"Min", "[", 
         RowBox[{
          RowBox[{"1", "-", "k"}], ",", 
          RowBox[{"1", "-", "k", "-", 
           RowBox[{"t", "[", "k", "]"}], "+", "p"}]}], "]"}]}], "&&", 
       RowBox[{"0", "<", "p", "<", 
        RowBox[{"Min", "[", 
         RowBox[{
          RowBox[{"t", "[", "k", "]"}], ",", 
          RowBox[{"k", "+", "l"}]}], "]"}]}], "&&", 
       RowBox[{"0", "<", "e1", "<", 
        RowBox[{"k", "+", "l", "-", "p"}]}], "&&", 
       RowBox[{"0", "<", "e2", "<", 
        RowBox[{"k", "+", "l", "-", 
         RowBox[{"p1", "[", 
          RowBox[{"l", ",", "p", ",", "e1", ",", "e2", ",", "k"}], "]"}]}]}], 
       "&&", 
       RowBox[{"0", "<", 
        RowBox[{"r2", "[", 
         RowBox[{"l", ",", "p", ",", "e1", ",", "e2", " ", ",", "k"}], "]"}], 
        "<", 
        RowBox[{"r1", "[", 
         RowBox[{"l", ",", "p", ",", "e1", ",", "e2", ",", "k"}], "]"}]}], "&&", 
       RowBox[{"0", "<", 
        RowBox[{"r1", "[", 
         RowBox[{"l", ",", "p", ",", "e1", ",", "e2", ",", "k"}], "]"}], "<", 
        "l"}]}], ",", 
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"l", ",", "p", ",", "e1", ",", "e2", ",", "k"}], "]"}], "-", 
       RowBox[{"P", "[", 
        RowBox[{"l", ",", "p", ",", "k"}], "]"}]}], ",", 
      RowBox[{"H", "[", 
       RowBox[{"t", "[", "k", "]"}], "]"}]}], "]"}]}], ";"}]}]}], "Input",
 CellChangeTimes->{{3.5354450902021*^9, 3.535445294279027*^9}, {
  3.535446050726191*^9, 3.535446067568989*^9}, {3.5354464382543793`*^9, 
  3.535446585967805*^9}, {3.535446939864554*^9, 3.535446940205895*^9}, {
  3.535447971848742*^9, 3.535447971959433*^9}, {3.5354483966238728`*^9, 
  3.535448408830111*^9}, {3.535448447093864*^9, 3.535448447317655*^9}, {
  3.535448754792482*^9, 3.535448754937211*^9}, {3.535460100730156*^9, 
  3.5354601315557137`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Data", " ", "Import"}], " ", "-", " ", 
    RowBox[{"Optimal", " ", "Params", " ", "for", " ", 
     RowBox[{"FD", " ", "/", " ", "BDD"}], " ", "scenario"}]}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"TParamsBD", "=", 
     RowBox[{"Import", "[", "\"\<Params_BD.dat\>\"", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"TParamsFD", "=", 
     RowBox[{"Import", "[", "\"\<Params_FD.dat\>\"", "]"}]}], 
    ";"}]}]}]], "Input",
 CellChangeTimes->{{3.535445304075968*^9, 3.535445340392171*^9}, {
  3.535445404071369*^9, 3.5354454171740627`*^9}, {3.535445466253202*^9, 
  3.535445487638404*^9}, {3.535445611549815*^9, 3.535445613907344*^9}, {
  3.535445649067048*^9, 3.5354456519932957`*^9}, {3.535446072377018*^9, 
  3.535446090945731*^9}, {3.535446694819808*^9, 3.535446697121965*^9}, {
  3.535446781179947*^9, 3.5354467841120863`*^9}, {3.535447799012487*^9, 
  3.535447812571505*^9}, {3.535460153459433*^9, 3.535460159481844*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"BDD", ":", " ", 
    RowBox[{
    "Computing", " ", "Running", " ", "Times", " ", "for", " ", "optimal", 
     " ", "Params"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"Make", " ", "sure", " ", "that", " ", "correct", " ", 
    RowBox[{"t", "[", "k", "]"}], " ", "function", " ", "is", " ", "employed",
     " ", 
    RowBox[{"(", 
     RowBox[{"top", " ", "of", " ", "this", " ", "document"}], ")"}]}], 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"Entries", " ", "of", " ", "the", " ", "form", " ", 
    RowBox[{"(", 
     RowBox[{"k", ",", "Complexity"}], ")"}]}], "*)"}], "\[IndentingNewLine]",
   "\[IndentingNewLine]", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"TParamsBD", "[", 
        RowBox[{"[", "i", "]"}], "]"}], "[", 
       RowBox[{"[", "5", "]"}], "]"}], ",", 
      RowBox[{"CompBJMM", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"TParamsBD", "[", 
          RowBox[{"[", "i", "]"}], "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}], ",", 
        RowBox[{
         RowBox[{"TParamsBD", "[", 
          RowBox[{"[", "i", "]"}], "]"}], "[", 
         RowBox[{"[", "2", "]"}], "]"}], ",", 
        RowBox[{
         RowBox[{"TParamsBD", "[", 
          RowBox[{"[", "i", "]"}], "]"}], "[", 
         RowBox[{"[", "3", "]"}], "]"}], ",", 
        RowBox[{
         RowBox[{"TParamsBD", "[", 
          RowBox[{"[", "i", "]"}], "]"}], "[", 
         RowBox[{"[", "4", "]"}], "]"}], ",", 
        RowBox[{
         RowBox[{"TParamsBD", "[", 
          RowBox[{"[", "i", "]"}], "]"}], "[", 
         RowBox[{"[", "5", "]"}], "]"}]}], "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", 
      RowBox[{"Length", "[", "TParamsBD", "]"}]}], "}"}]}], "]"}]}]], "Input",\

 CellChangeTimes->{{3.535447830137438*^9, 3.535447937465177*^9}, {
  3.535447982950994*^9, 3.53544809165467*^9}, {3.535448386615933*^9, 
  3.5354483905598097`*^9}, {3.535448439606985*^9, 3.5354484398711576`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.1`", ",", "0.0230131416323929`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.2`", ",", "0.036630021080173415`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.3`", ",", "0.04480387666736209`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.4`", ",", "0.048740045944085236`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.45`", ",", "0.04931429898114672`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.5`", ",", "0.04903869369220645`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.6`", ",", "0.045987620717964`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.7`", ",", "0.03975543778957026`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.8`", ",", "0.030317647176179262`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.9`", ",", "0.01741894896787947`"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.5354478327768383`*^9, 3.535447864557675*^9}, 
   3.535447938872088*^9, 3.53544805603078*^9, 3.53544809227052*^9, {
   3.535448391292008*^9, 3.535448400497911*^9}, 3.5354484505051003`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"FDD", ":", " ", 
    RowBox[{
    "Computing", " ", "Running", " ", "Times", " ", "for", " ", "optimal", 
     " ", "Params"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"Make", " ", "sure", " ", "that", " ", "correct", " ", 
    RowBox[{"t", "[", "k", "]"}], " ", "function", " ", "is", " ", "employed",
     " ", 
    RowBox[{"(", 
     RowBox[{"top", " ", "of", " ", "this", " ", "document"}], ")"}]}], 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"Entries", " ", "of", " ", "the", " ", "form", " ", 
    RowBox[{"(", 
     RowBox[{"k", ",", "Complexity"}], ")"}]}], "*)"}], "\[IndentingNewLine]",
   "\[IndentingNewLine]", 
  RowBox[{"TValuesFD", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"TParamsFD", "[", 
         RowBox[{"[", "i", "]"}], "]"}], "[", 
        RowBox[{"[", "5", "]"}], "]"}], ",", 
       RowBox[{"CompBJMM", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"TParamsFD", "[", 
           RowBox[{"[", "i", "]"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", 
         RowBox[{
          RowBox[{"TParamsFD", "[", 
           RowBox[{"[", "i", "]"}], "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}], ",", 
         RowBox[{
          RowBox[{"TParamsFD", "[", 
           RowBox[{"[", "i", "]"}], "]"}], "[", 
          RowBox[{"[", "3", "]"}], "]"}], ",", 
         RowBox[{
          RowBox[{"TParamsFD", "[", 
           RowBox[{"[", "i", "]"}], "]"}], "[", 
          RowBox[{"[", "4", "]"}], "]"}], ",", 
         RowBox[{
          RowBox[{"TParamsFD", "[", 
           RowBox[{"[", "i", "]"}], "]"}], "[", 
          RowBox[{"[", "5", "]"}], "]"}]}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", 
       RowBox[{"Length", "[", "TParamsFD", "]"}]}], "}"}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.535448110253601*^9, 3.535448147636636*^9}, {
  3.5354484361829643`*^9, 3.5354484378871107`*^9}, {3.535460227187686*^9, 
  3.535460233456808*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.1`", ",", "0.053104093145360395`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.2`", ",", "0.08077077000361055`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.3`", ",", "0.09576170503968648`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.4`", ",", "0.10160204108769104`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.45`", ",", "0.10165305062404854`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.5`", ",", "0.09998623351891212`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.6`", ",", "0.09191796807961174`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.7`", ",", "0.0778839346147999`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.8`", ",", "0.05820699064752487`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.9`", ",", "0.03273910120797096`"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.535448137357793*^9, 3.535448148954266*^9}, {
   3.535448412789729*^9, 3.535448442620392*^9}, {3.535460183964711*^9, 
   3.53546019258823*^9}, 3.53546023441219*^9, 3.535460300493065*^9, 
   3.535460342194543*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"Interpolation", " ", "and", " ", "Plot"}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"TValuesFD", "=", 
     RowBox[{"Prepend", "[", 
      RowBox[{"TValuesFD", ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"TValuesFD", "=", 
     RowBox[{"Append", "[", 
      RowBox[{"TValuesFD", ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"bjmm", "=", 
     RowBox[{"Interpolation", "[", "TValuesFD", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"bjmm", "[", "x", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", "1"}], "}"}]}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{"FindMaximum", "[", 
    RowBox[{
     RowBox[{"bjmm", "[", "x", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0.5"}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5354602070840473`*^9, 3.535460323116333*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwV1nk8lGsbB3BJnbKMUAotEqlQjrQqP1HJVraiklYtEpIW0UuFQyVZEoVk
D9myzDM4UZYiSxjMPDMGSZaYdKho8d79NZ/vZ571d9/PdV1Lj7lZO4mKiIgw
pomI/Pk1dep/Vz6wV19ExG+tYdFufTEjRXeBgi5ERrxuyC/XxNrH0bHPFbZD
RM35XMuSLTCrb8+PU7CFQcHT0Cw5c9id+FYWrnACfhtGbsf8OAj+mn+MQhQ8
8Xln3vKyurNImLcn8JaCPxIq8nZyXbxxfdZz9WCFSFwxdOo2yr8F+/1Pcj6P
JkNn50TxRr2HkJi67mC8OAcppQJze/dEqFmN9L+6XYCk8B0G+6TTcLlhE6LH
KNRK+AtfXczE/AKZzmnTXoAZcODJPokcFPUYvW3c8hLskYeO8evy8NI5Tmn/
p0rUnPCefzApH+PLt0o/O1eDL1rJEkZ1zyE6kTlHSa0W3LPL7tzsK8D6qSNF
NtlvoSAYL5fkF+Ktv25D9apG/FC8lK6dV4Ql94Ymno40YZu3Qs+2K8UY+ibo
ZGs3Y95js9Cn8kwUnQp9abqeOCOmR1mBCb92/dQXes1gazJORykxIV8cd+7p
zmbIW6dJ+CgzYXjp4E8fh2YsVDeq+nsVEw/H2hRUg5qx1e6Mr/FWJnaN1tt6
CMjxufkTS44xkTxYUsu424Lq9x8X56Qx4fpgzzLniBb4qGndLHvKxIbt772r
oltgrqqxqzaTido4cS2fpBZUfHEa78xhYtRyf+gAswXlM071jhUzoV/81aby
fQv4MQusWmqY4Nz8m++1qRWLVu40cehjgrEoTdjb24ofdtrsZ4spGOy7yX8/
0Ar+X8zxTcoUPEIP1/WMtCLwuVxp5VIKbdMWpHV9b8XoAXW9NlUK8X1BjjxJ
Nh5e6Jk1sIrC6lzn+hZdNh7ML5VrWE/Bwmh15kt/NmQDHrs9sKDwPx/xmIpg
Nt7E2RR/300ht7AvsPwuG1eiOzPtLSnMXfH42L/RbATc2x8714YCT3KOIiuL
jeq5M5/42FNwaRsNymtlw5CycJY6TuHOmcKTCaptmHy7KWDtZQqDBs+CJFa1
4Ux4s1LAFQrGC1IyLq1pg7VKkQbbi4JoTeSI+eY2NPV6M919KHipel6a2NMG
xTp2yP3rFE4KdAKtvdvAfnf0ZNRtCtv25qaINbfBy63p1aV48r6a6TVu7W0Y
nnuWEf2Yws/pCQNcXhsK4w3p4gQKzPxQrbyPbbiWWP3zSyLJY45b4aFfbbiz
7etJuzQKC+u0qopWtCM8PFyek0Phq0Fm72nfdtSpF7ZXvKBQmjz06LJ/OwRr
yzqTyincmKVpExjcjv3t4wn+FRQYTVkVSRHtiMzotjN8RWH54ez4zrR2FH4S
icquprDvWp69bVM7xHVNAk3rKRRSxW+xtAPnPQ42hHEoXF30/ebu5R1QOrQ+
y4xL1vv6Rr1DGh2olw4yF6MpvN1FPb26rgOOEVfY53kUettZgYUmHSi/NsTQ
F5D1+VpmoOHRgf/Witk86qXgqVNZIP+qAzfeHCx2HiH56SonhL3ugMzwnX9m
CynYr/e5LdnQgV2SV4dSifU26x4T5XQg5HiuG/8zWQ/DZOmRkQ7E/y/1/Kb/
KIRa+TtXKXKgm+sX++wbBT+brr0Gyhyk/FarW/ed7Me9W7aVqHFg1KUeXkq8
b//Y/DxtDgZunBmsmiD5Hj1RFbuTA7E9v+pqflDIcN+u7OnBwVuzNZFBUxRi
PRIkhJc58N1qfXaSOMTz59cz1zjo3e8hcBZhwf1KQf3hIA4yNjY/Np7GwgY/
VW+zeA4kqldK/SfKwoobfierkzj4wjJ64TCdBUV/ntW2pxykjbtJVBH//idy
xYYCDj6UvfAIE2OhMlSsTaWW3G+Z3w2FmSwUhR2piGvkILvJTfwKcXpEadYC
NgdXq79osYlvP/C8yejiwFbqwq7bf7Fg/bhXe3Kcg86whKa+WSwIsitvv1vK
xc/KOruDEiw0DYt90lHnItHk0tFE4nLNHeaRmlySz0X5fuKEjCpJuw1clJxf
ddNNkoVjqdUhPHMuXM+ccHGVItf/MHNkqzUXrRX57AxiI1Xj3Y/tuKgIejn0
gVg1sYZx7BgXF+7xFtszWOiLex368TIX6nXjKZrSLLTxZn3edY2LTNr0qiNx
jZKJZcYNLrYV1/+8S5we82bOuRAuBn7JSn0iju6Yfb4hnIvFftqPFsxhIXi+
6bs10Vxk/fi7w4jY+X5t2JdELuZJPTgcRXygVfyLTToXcqy9GWXEZnJm1oXP
uMi9m538nlgzrE72CpOL2fzedA0ZFhY2SVzglHHRf27RcwtiSWnzls2vyPPZ
pp5zJR6+8zbiVz0Xy6wPj2USd9ZJjjm2cDHpO1j+mrhB3MK2vIPk+7ePfi9x
dlD93JvvSR6WZyzmy7IQXyN1sbefi/TWJYLVxKEzd7N3jHDxWzxCZQexu3/D
/VkTXBiUOb04R3zkFePrmd9cWFgqK/gRW4nu2Vc3nYZMpYVaGLHhttAizdk0
lJKVehOIdfwa5e8yaPzyLt6bQ6zyQvqyUI6GSfvuq6XEcr/3tFsq0AjbJm39
mlhs670N+YtpOO1czm8mHvNueiCnSsPufIUSj7iXNee750oaExYMRi8xe8LS
vm01Dd6pzQWDxNUbw5gbdGmEm15gfCYuuvxuQcwmGlnX+xaOEacWyXhN6tMo
ia4QfCV+MG7FObidhpWSjt134iDd8E1lJjSmIp1u/vGVC80xi/fQsA8LPvGN
+HS+7KSvLY2hR3WTf663f9T6QPd+GuYG+3eOEptqR7AMD9MQFz9i/Il4s1uL
YvIJGpS/1O8PxKuy5bxnONMY0At17iRWHLahT7rR0CiRDWETi2tG6r32JHne
rXKqI/7h3Ppo5VUaWgbssRfEtusPha32Jflcc1xSQJw1rS9wrT+Nvz2sNNKI
Z9S7+mwMprFMoWVBDLFj9LfzW+/SaHKZ1R9MXHzc75RhBI3aU/IxXsRz1sw+
ZBxNI0VMRfM0cUWV4i6rRLI+jOrv2/48X1jS1n1pNDa5p+toEXs4aK49mEVj
n+PCPX/2j+p/Wxc7FdE4+cZcu5/sr2v/Vss5l9Dw1bMZbyBuC94z262chpyq
b1wB8T/KR8eu1NL4akg/8CHuGhoYuNZIw8V176Aj8cZiD8GNVhoZk0HKBsSD
Fv61dzpp1CzJ3ThFvg8L77SEhC800sTEF7oTp+7Ujkr5RsMj/sA9E+LfMtTt
jJ804s7dGVhKnJtee6lgJg9OUepmjeR7lWsbNn+tyEODl3HjQmKXJ5cM65fw
ULL8meswqQeVLlMbmlV5SOIrjZUSX5ous4y3moc8m/S8P/WCo607ITTkgfc6
6McNUk90fpaOjBmT87UMG02Jb9Xs6J0w52H1ec1bMsRbHO0ap9vxsPh/6kWP
SL16fPtqyvyzPOxY8GrwT337vm/6o4XuPPRwGD+PEluq3Lm39CIP2bufjy8h
FqXivDV8yflbHiZGi7Pg1FduhQgevO4O9fnMZkFj21+/T5bwMGT1bZMMqa+5
GZnqHeU8RFic6Csm9Vd3rqWVSTUPzaebzA8Rb/kYnazxjofhE3Rf8gwWdoes
MvvcxwNb/Vz+clLfPTgW0V6yfFw/kHp8mPSPr4ZfKgbn87GK+S7Qj9g7K2ro
4CI+CpPXnZQl9vcV6Ouv4CNYa/UBHdJ/otTOfxDV56NHLkLx+C8K1PlInTtn
+JDoLlAMIv1Mn97o8MuVDzpYT+Yv4pfb+QGunnyM1ctX+5P+Vzt/OcfSlw9l
DeuzPqRf8sqKfefd50NqT0iawzgFEXH6bXw5H5ODcWLdpN8aJy49lTe/E/yu
c1sn+yjoRjOWVy/sxDrtu74OxMp3f/Ryl3YiOGg0q+wDhUkv9jExzU4obRC+
8SH9/plVsKOdQSfiy2ukR7opyE0b3fvrdCeaV33riSXzguBw+XYTVieOB8ee
0nxH5om9z6Y7vujEso92xi5NZD4ye/jSo7ITd5yq5mU2Ugjf4GkQ29AJkzRV
X7UGCjukV2wR9nRi1YXxQKk6Cpn/hq69LyHA+uaBGxmVFC4vOqzS7SDAKNf5
04JiCscstffxjgrwwr3OVK+Iwu6b0261nxSg8XJdikMhmY8Gkkbr3QUoOy5j
HfucQmtBfznLXwBRr+BA6VwK2uYehyOzBAivbbpYlU6h/2pArPFPARbdH1Zx
j6Gg+WmvRLtFF8JlNiSLknmSaWv+4pZlF1Qs7/c0XKJgVGZ4Qd+mC6VKT7/H
XKRw4O4aOsW+Czlya7M0L1AI1p6d6Xm8C4sfxupsd6XQ51lqKuvVhYC45XV6
Jygk/FK5ZZHchTNHleIt9pA8pT/PqpzsgsF49vEpMm83l936x+RXFyLuG0Y8
IvN4uIvazMapLqRYHKtcv4SCbO2B6VyxbvS4ems4LyQOqPolZHQj6cAtRpU8
hTk/Hn5RWtaNsN9v1ppJUJD8uIN3wawbJ/JN7GP+Y0LsxaOcZbHdsIydO44K
Js7qlnBmm/XgKq/LJmsnE5kmxxL+/doDGZ9S/bTSYowPKc7pi3oPqRrJcC/N
YhTaGE+P3N4L+/51Oed8i+C7K+BxQV8vZj8ZzLZsKMRSvmlHUsAHWEcpRBnI
FmLzBv9IBZ0+fPgvfo7O+gI4LG6cmNbSh+KHTYyiA88xXhvS4379Izr2JfHG
HPIRLeboaa3aD+sm8/KSI3mQ6yxMFK3sx7y1sZA+mIsZ167bbjo/AKGShbKk
YzZEnjrm9MgOYlH+5ZVJclnweJgTIvtyEL1ri+JmXX6KMo2gWTKuQ9he9Ptj
SUUqZEw9NG8wPsFjsL3r0oJk8LSaWrxKP2HXtGB9B8YT5MZDtddxGNuHVpam
qsTiUM56mUW/h2FiNVS058d9+AU8uc7LGEFkLSOh61MInvUvesQwFyJgSop3
a4UfguICjnTuFkIQvO7ZshZfnLAeVsu2EiLl1boJ+b2+WFhammthJ8S6qUsB
z+z/h1uhB6vvHBPiUR77R4yjD06vjxkV9xJCo+NttYvTFaj4z931V6oQT7v7
JfiO7vi90UeqPZ38f3XGW6USN3CG3zenZgrxYHPzcmOmK+7ZPT+0M0+IeeaW
OZN5LphaZX0hoFSI/f331FoTT4P3LjR+eosQ5QWFniZXj4AZ+O14C1uII35D
rjf7HRGpd3hlUocQ6bZnNs/kOcAsZXWBYacQg8phR19W2IN1pf7N9QEhWnPG
l8kFWSJKa12o1SchnDbfU1gxao7zPbG2S4XEW366WbzbhRXmLoLyMSHaA0LV
RUMNIDatNfneNyEk3VtCVDgb0VWo53xkUgjRuu6GwHBtlDonrdH+JUQsYzLh
aKQyHiyRGJ+aEkKp0XK2ywoD/f8DISpbEA==
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 1}, {0., 0.10185197074823192`}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{{3.5354602810888147`*^9, 3.535460345338372*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.1018519759268873`", ",", 
   RowBox[{"{", 
    RowBox[{"x", "\[Rule]", "0.42625531234847`"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.5354602810888147`*^9, 3.5354603453504066`*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "Optimization", " ", "for", " ", "variable", " ", "dimension", " ", "k"}],
     ",", " ", 
    RowBox[{
    "be", " ", "aware", " ", "of", " ", "using", " ", "the", " ", "correct", 
     " ", "definition", " ", "of", " ", 
     RowBox[{"t", "[", "k", "]"}], " ", 
     RowBox[{"w", ".", "r", ".", "t", ".", " ", "the"}], " ", 
     RowBox[{"BDD", " ", "/", " ", "FD"}], " ", "scenario"}]}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"k", ":=", "0.9"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"NMinimize", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"CompBJMM", "[", 
        RowBox[{"l", ",", "p", ",", "e1", ",", "e2", ",", "k"}], "]"}], ",", 
       RowBox[{
        RowBox[{"0", "<", "p", "<", 
         RowBox[{"t", "[", "k", "]"}]}], "&&", 
        RowBox[{"0", "<", "l", "<", 
         RowBox[{"1", "-", "k"}]}], "&&", 
        RowBox[{"0", "<", "e1", "<", 
         RowBox[{"1", "-", "k", "-", "p"}]}], "&&", 
        RowBox[{"0", "<", "e2", "<", 
         RowBox[{"1", "-", "k", "-", 
          RowBox[{"p", "/", "2"}], "-", "e1"}]}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"l", ",", "p", ",", "e1", ",", "e2"}], "}"}], ",", 
     RowBox[{"MaxIterations", "\[Rule]", "200"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.535448543638674*^9, 3.535448580595293*^9}, 
   3.535448751192576*^9, {3.535448947555792*^9, 3.5354489761150713`*^9}}]
},
WindowSize->{1869, 1036},
WindowMargins->{{Automatic, 0}, {Automatic, 0}},
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (February 23, \
2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 11910, 335, 493, "Input"],
Cell[12470, 357, 1046, 23, 58, "Input"],
Cell[CellGroupData[{
Cell[13541, 384, 2085, 55, 88, "Input"],
Cell[15629, 441, 1074, 25, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[16740, 471, 2107, 56, 88, "Input"],
Cell[18850, 529, 1098, 26, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[19985, 560, 1121, 35, 103, "Input"],
Cell[21109, 597, 5881, 102, 239, "Output"],
Cell[26993, 701, 232, 5, 27, "Output"]
}, Open  ]],
Cell[27240, 709, 1482, 37, 58, "Input"]
}
]
*)

(* End of internal cache information *)
